//BHC - Nstroj pro kompresi pomoc Bufferovanho Huffmanova kdu
//vygenerovan kd nesm obsahovat ladc informace (po kompilaci pout TDSTRIP)

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include <io.h>
#include <dir.h>
#include <dos.h>
#include "bitio.h"

#pragma warn -pia
#define PARAM_CHAR '/'
#define EXCLUDE_CHAR '!'
#define PATH_DIVIDER '\\'
#define MAX_FILENAME 127
#define NPPVSS "Nedostatek pamti pro vytvoen seznamu soubor"

int scr_write; //indiktor vpisu na obrazovku

typedef char FNAME[MAX_FILENAME];
typedef struct _FILES {
	char *name;
	struct _FILES *next;
} FILES; //struktura pro uloen vce nzv soubor

typedef struct {
	FNAME fname;
	long fsize;
	unsigned fdate;
	unsigned ftime;
	unsigned fattr;
} FINFO;

typedef struct {
	unsigned count; //poet vskytu prvku
	unsigned saved_count; //hodnota count po jejm vynulovn pi vrob stromu
	int left, right; //index levho a pravho nsledovnka
} TREE[514]; //0..255 jsou ASCII znaky, 256 je termintor, 257..512 jsou uzly, 513 je pomocn

typedef BITS VALUES[257]; //bitov kdy ukldanch znak
typedef unsigned char *BUFFER;

typedef struct {
	unsigned attrib : 1;
	unsigned absnames : 1;
	unsigned erase : 1;
	unsigned extract : 1;
	unsigned onlynames : 1;
	unsigned pathnames : 1;
	unsigned recurse : 1;
	unsigned sfx : 1;
	unsigned std_in : 1;
	unsigned std_out : 1;
}	PARAM;




void error(int code, char *message) { if (scr_write) fprintf((scr_write == 1) ? stderr : stdout, "\nKritick chyba: %s\n", message); exit(code); }

int printaf(char *action, char *filename) { return scr_write ? fprintf((scr_write == 1) ? stderr : stdout, "%-10s %-*s", action, 14 + 7 * (strlen(filename) / 7 - (strlen(filename) >= 7)), filename) : 0; }
int printdf(char *action, int counter) { return scr_write ? fprintf((scr_write == 1) ? stderr : stdout, "\n%s%s %d %s\n", action, (counter == 1) ? "" : (counter > 1 && counter < 5) ? "y" : "o", counter, (counter == 1) ? "soubor" : (counter > 1 && counter < 5) ? "soubory" : "soubor") : 0; }
int printef(char *str) { return scr_write ? fprintf((scr_write == 1) ? stderr : stdout, str) : 0; }
int printnf(char *str) { return scr_write ? fprintf((scr_write == 1) ? stderr : stdout, "%s\n", str) : 0; }
int printpf(float percent) { int x; int result = 0; if (scr_write) { x = wherex(); result = cprintf("%5.1f%%", 100 * percent); gotoxy(x, wherey()); } return result; }
//funkce pro jednotnou podobu vpis, tisk se provede podle nastaven promnn scr_write

char *strbcpy(char *dest, char *src1, char *src2) {
//dest = src1\src2
	if (src1[0]) {
		strcpy(dest, src1);
		if (src1[strlen(src1)-1] != PATH_DIVIDER)
			{ dest[strlen(dest)+1] = 0; dest[strlen(dest)] = PATH_DIVIDER; }
		strcat(dest, src2);
	} else strcpy(dest, src2);
	return dest;
}

int strcmpe(char *se, char *s) {
	int i, j, pose, pos;
	for (i=0; se[i] != '*'; i++) {
		if (!se[i] || !s[i]) return (!se[i] && !s[i]); //konec etzce
		if (se[i] != s[i] && se[i] != '?') return 0; //porovnn
	}
	for (j = i; se[i] || s[j]; ) {
		if (se [i] == '*') {
			while (se[i] == '*') i++;
			if (!se[i]) return 1; //konec etzce po hvzdice
			pose = i; pos = j;
		}
		if (se[i] && (se[i] == '?' || se[i] == s[j])) { i++; j++; }
		else {
			i = pose; j = pos+1;
			while (s[j] != se[i] && s[j] && se[i] != '?') j++;
			if (!s[j]) return 0;
			pos = j;
		}
	}
	return 1;
}

int overwrite(int *overwriting, char *filename) {
//obsluha pepisovn
	int over = -1;
	switch (*overwriting) {
		case 'V': over = 1; break;
		case 'D': printaf("Peskakuji", filename); printnf(""); over = 0; break;
		default:
			printaf("Nalezeno", filename);
			printef("Pepsat? [A,N,V,D,K,?] ");
			while(over == -1) {
				switch (toupper(getch())) {
					case 'A': printef("Ano"); over = 1; break;
					case 'N': printef("Ne"); over = 0; break;
					case 'V': printef("Vechny"); *overwriting = 'V'; over = 1; break;
					case 'D': printef("Dn"); *overwriting = 'D'; over = 0; break;
					case 'K': printef("Konec"); error(5, "Perueno uivatelem"); break;
					default: printef("\nAno, Ne, Vechny, Dn, Konec "); break;
				}
			}
			printnf("");
	}
	return over;
}





int build_tree(TREE tree) {
//postav strom vskyt, oekv strom s prvn polovinou naplnnou vskyty, vrt koen stromu
	int i;
	int active;
	int next_free;
	int min, min2;

	for (i=257; i <= 513; i++) tree[i].count=0;
	for (i=0, active=0; i <= 256; i++) if (tree[i].count) active++; //poet aktivnch prvk

	for (next_free = 257; active > 1; next_free++, active--) {
		min = 513; min2 = 513; // v prvku 513 je vdy 0
		for (i=0; i < 513; i++) //nalezen dvou nejmench prvk
			if (tree[i].count && (!tree[min].count || !tree[min2].count || tree[i].count < tree[min2].count)) {
				if (!tree[min].count) min=i;
				else if (tree[i].count < tree[min].count) { min2=min; min=i; }
				else min2=i;
			}
		tree[next_free].count = tree[min].count + tree[min2].count;
		tree[next_free].left = min;
		tree[next_free].right = min2;
		tree[min].saved_count = tree[min].count;
		tree[min2].saved_count = tree[min2].count;
		tree[min].count = 0;
		tree[min2].count = 0;
	}

	next_free--;
	tree[next_free].saved_count = tree[next_free].count;
	return next_free;
}

void write_tree(BITFILE *archive, VALUES values, TREE tree, int node, unsigned data, int count) {
//rekurzivn, piad uzlm bitov hodnoty a zrove zapisuje podobu stromu do souboru
	if (node <= 256) {
		values[node].data = data;
		values[node].count = count;
		putb(1, archive);
		putbits(node%256, 8, archive);
		if (!(node%256)) putb(!!node, archive); //jestlie je kd 0 nebo 256, zapu jet jeden rozliovac bit
	} else {
		putb(0, archive);
		write_tree(archive, values, tree, tree[node].left, (data << 1) | 0, count + 1);
		write_tree(archive, values, tree, tree[node].right, (data << 1) | 1, count + 1);
	}
}

void compress(BITFILE *archive, FILE *file, BUFFER buffer, long maxbuf, long fsize) {
//oekv oteven archiv se zapsanou hlavikou, oteven soubor a alokovan buffer
	unsigned i;
	int ch;
	VALUES values;
	TREE tree;
	unsigned buffer_count;
	unsigned char checksum;
	long written = 0;
	long apos = ftell(archive->file), bpos;

	while (!feof(file)) {
		for (i=0; i <= 255; i++) tree[i].count=0;
		tree[256].count=1; //tree[256] je rezervovn pro EOF

		for (i=0, checksum=0; i<maxbuf && (ch = getc(file)) != EOF; i++) { //naplnn bufferu, vskyty do stromu
			buffer[i] = ch;
			checksum ^= ch;
			tree[ch].count++;
		}
		buffer_count = i;
		if (buffer_count) {
			write_tree(archive, values, tree, build_tree(tree), 0, 0);
			for (i=0; i < buffer_count; i++) //zpis
				putbits(values[buffer[i]].data, values[buffer[i]].count, archive);
			putbits(values[256].data, values[256].count, archive); //EOF
			putbits(checksum, 8, archive);
			if (feof(file)) putb(1, archive); else putb(0, archive); //bit pro uren toho, zda dal data pat ke stejnmu souboru
			written += buffer_count;
			printpf(fsize ? (float) written / fsize : 0.0);
		}
	}

	putbuf(archive);
	bpos = ftell(archive->file);
	fseek(archive->file, apos - 4, SEEK_SET);
	putbits(bpos - apos, 32, archive);
	fseek(archive->file, 0, SEEK_END);
	printpf(fsize ? (float) (bpos - apos) / fsize : 0.0); //vpis kompresnho pomru
}

void write_header(FILE *file, FINFO finfo) {
	int i;
	for (i=0; finfo.fname[i]; i++) putc(finfo.fname[i], file);
	putc(0, file);
	putc(finfo.fattr % 256, file);
	putc(finfo.fdate / 256, file); putc(finfo.fdate % 256, file);
	putc(finfo.ftime / 256, file); putc(finfo.ftime % 256, file);
}

FILES *expand_mask(FNAME mask, FILES *firstfile, FILES *files, FNAME dirname, PARAM param) {
//masku files->name zamn za seznam odpovdajcch soubor, vrt ukazatel na posledn vyexpandovan soubor
//nepidv ji pidan soubory, nepidv vylouen soubory, je-li to douc, rekurzivn prochz podadrese
	int done;
	struct ffblk ffblk;
	FILES *f;
	FNAME sdirname, fname;
	int found;
	char *str, *str2;

	if (mask[strlen(mask)-1] == PATH_DIVIDER) mask[strlen(mask)-1] = 0;
	if (!strchr(mask, '?') && !strchr(mask, '*') && !findfirst(mask, &ffblk, FA_DIREC) && (ffblk.ff_attrib & FA_DIREC)) strbcpy(mask, mask, "*.*"); //jako parametr jsem zadal jmno adrese

	strcpy(sdirname, dirname);
	strncat(dirname, mask, (str = strrchr(mask, PATH_DIVIDER)) ? str - mask + 1 : 0);
	strcpy(mask, (str = strrchr(mask, PATH_DIVIDER)) ? str + 1 : mask); //pehozen adres z masky do dirname
	strbcpy(fname, dirname, mask);
	done = findfirst(fname, &ffblk, 0);
	if (done && !sdirname[0]) { printaf("Nenalezeno", strupr(fname)); printnf(""); }
	while (!done) {
		strcpy(fname + strlen(dirname), ffblk.ff_name); //zmna masky za skuten jmno souboru
		for (found = 0, f = firstfile; firstfile != files && !found && f != files; f = f->next) //prchod zatkem seznamu kvli duplicitm
			found = !strcmpi((param.onlynames && (str = strrchr(f->name, PATH_DIVIDER))) ? str + 1 : f->name, (param.onlynames && (str2 = strrchr(fname, PATH_DIVIDER))) ? str2 + 1 : fname);
		for (; !found && f; f = f->next) //prchod koncem seznamu kvli vylouenm souborm
			found = (f->name[0] == EXCLUDE_CHAR && strcmpe(strupr(f->name) + 1, ffblk.ff_name));
		if (!found) {
			f = files->next;
			if (!(files->next = malloc(sizeof(FILES)))) error(2, NPPVSS);
			files = files->next;
			files->next = f;
			if (!(files->name = malloc(strlen(fname)+1))) error(2, NPPVSS);
			strcpy(files->name, fname);
		}
		done = findnext(&ffblk);
	}

	if (param.recurse) { //rekurzivn prchod podadres
		strbcpy(sdirname, dirname, "*.*");
		done = findfirst(sdirname, &ffblk, FA_DIREC);
		while (!done) {
			if ((ffblk.ff_attrib & FA_DIREC) && ffblk.ff_name[0] != '.') {
				strbcpy(sdirname + strlen(dirname), ffblk.ff_name, "");
				files = expand_mask(mask, firstfile, files, sdirname, param);
			}
			done = findnext(&ffblk);
		}
	}
	return files;
}

int compress_files(BITFILE *archive, FILES *firstfile, unsigned maxbuf, PARAM param) {
//vytvo jednoznan seznam soubor a vechny zapakuje
	BUFFER buffer;
	FNAME mask;
	FILES *ffind, *files = firstfile, *fprev = firstfile;
	FILE *file;
	FNAME fname, curdir;
	FINFO finfo;
	int counter = 0;
	char *str;
	struct time atime; struct date adate;

	printnf("\n");
	if (!param.std_in) while (files) { //prochzen vech zpracovvanch soubor
		if ((param.absnames || param.pathnames) && files->name[0] != EXCLUDE_CHAR) //vytvoen absolutn cesty vetn nzvu disku
			if (strchr(files->name, ':')) strcpy(mask, files->name);
			else if (files->name[0] == PATH_DIVIDER) sprintf(mask, "%c:%s", 'A' + getdisk(), files->name);
			else {
				getcurdir(0, curdir);
				if (curdir[0]) { curdir[strlen(curdir)+1] = 0; curdir[strlen(curdir)] = PATH_DIVIDER; }
				sprintf(mask, "%c:%c%s%s", 'A' + getdisk(), PATH_DIVIDER, curdir, files->name);
			}
		else strcpy(mask, files->name);
		if (mask[0] == EXCLUDE_CHAR) //jestlie je to vyluovac soubor, pouze ho vymau
			if (files == firstfile) { firstfile = firstfile->next; free(files); files = fprev = firstfile; }
			else { fprev->next = files->next; free(files); files = fprev->next; }
		else { //nevyluovac soubor
			curdir[0] = 0;
			ffind = expand_mask(mask, firstfile, files, curdir, param); //doplnn seznamu
			if (files == firstfile) firstfile = firstfile->next;
			else fprev->next = files->next; //odstrann souboru s maskou
			if (ffind != files) fprev = ffind; //maska se rozila
			if (files == ffind) { files = ffind->next; free(ffind); fprev = files; }
			else { free(files); files = ffind->next; }
		}
	}

	if (!(buffer = malloc(maxbuf))) error(2, "Nedostatek pamti pro alokaci bufferu");

	for (files = firstfile; param.std_in || files; files = files->next) { //prochzen jednoznanho seznamu soubor
		if (param.std_in) {
			_streams[0] = *freopen("CON", "rb", stdin);
			file = stdin;
			strcpy(fname, "stdin.");
			getdate(&adate); finfo.fdate = (adate.da_year-1980) << 9 | adate.da_mon << 5 | adate.da_day;
			gettime(&atime); finfo.ftime = atime.ti_hour << 11 | atime.ti_min << 5 | atime.ti_sec >> 1;
			finfo.fattr = finfo.fsize = 0;
		} else {
			strcpy(fname, files->name); strupr(fname);
			if (strrchr(fname, '.') <= strrchr(fname, PATH_DIVIDER)) strcat(fname, "."); //u jmna chyb ppona
		}

		printaf("Pakuji", param.std_in ? "(stdin)" : (param.pathnames) ? fname + 2 : fname);
		if (!param.std_in && !(file = fopen(fname, "rb"))) printef("Nelze otevt");
		else {
			if (param.onlynames && (str = strrchr(fname, PATH_DIVIDER))) strcpy(finfo.fname, str + 1);
			else if (param.pathnames && (str = strchr(fname, ':'))) strcpy(finfo.fname, str + 1);
			else strcpy(finfo.fname, fname);
			_dos_getftime(fileno(file), &finfo.fdate, &finfo.ftime);
			_dos_getfileattr(fname, &finfo.fattr);
			fseek(file, 0, SEEK_END); finfo.fsize = ftell(file); fseek(file, 0, SEEK_SET);
			write_header(archive->file, finfo);
			putbits(param.std_out, 32, archive); //msto na uloen velikosti, kdy zapisuji na stdout, nemu se vracet (kvli zapsn skuten dlky dat), proto alespo zapu nenulovou dlku
			compress(archive, file, buffer, maxbuf, finfo.fsize);
			counter++;
			if (!param.std_in && fclose(file)) error(1, "Nelze zavt vstupn soubor");
			if (!param.std_in && param.erase && unlink(fname) && scr_write) { gotoxy(wherex()+8, wherey()); printef("Nelze smazat"); }
		}
		printnf("");
		if (param.std_in) break;
	}

	free(buffer);
	strcpy(fname, archive->name);
	if (bclose(archive)) error(1, "Nelze zavt archiv");
	printdf("Zapakovn", counter);
	if (!counter && !param.sfx && unlink(fname)) printef("Nelze smazat przdn archiv");
	return 0;
}





int read_tree(BITFILE *archive, TREE tree, int root) {
//rekurzivn naten stromu, nvratov hodnota je pro intern potebu
	unsigned node;
	int next_free;
	int i;

	if (getb(archive)) {
		node = getbits(8, archive);
		if (!node) node |= getb(archive) << 8;
		return node;
	} else {
		i = read_tree(archive, tree, root + 1);
		if (i<=256) { tree[root].left = i; next_free = root + 1; }
		else { tree[root].left = root + 1; next_free = i; }
		i = read_tree(archive, tree, next_free);
		if (i<=256) { tree[root].right = i; return next_free; }
		else { tree[root].right = next_free; return i; }
	}
}

void extract(BITFILE *archive, FILE *file, int write_mode) {
//rozbalen souboru, oekv oteven archiv a vstupn soubor
	int i;
	TREE tree;
	unsigned char checksum;
	unsigned long fsize;
	long apos;

	if ((fsize = getbits(32, archive)) > 0) {
		apos = ftell(archive->file);
		if (write_mode) do {
			for (i=0; i <= 513; i++) tree[i].left = tree[i].right = 513;
			read_tree(archive, tree, 257);
			checksum = 0;
			do {
				for (i = 257; i > 256; ) {
					#pragma warn -eff //code has no effect
					if (_getb(archive)) i = tree[i].right;
					#pragma warn +eff
					else i = tree[i].left;
				}
				if (feof(archive->file)) error(4, "Neoekvan ukonen archivu");
				if (i < 256) { putc(i, file); checksum ^= i; }
			} while (i != 256);

			if (getbits(8, archive) != checksum) error(4, "Nesprvn kontroln souet");
			printpf((float) (ftell(archive->file) - apos) / fsize);
		} while (!getb(archive)); //bit urujc, zda data pat ke stejnmu nebo dalmu souboru
		else fseek(archive->file, fsize, SEEK_CUR);
	}
	clearbuf(archive);
}

int read_header(FILE *file, FINFO *finfo) {
	int ch, i;
	for (i=0; (ch = getc(file)) > 0; i++) finfo->fname[i] = ch;
	finfo->fname[i] = 0;
	finfo->fattr = getc(file);
	finfo->fdate = 256 * getc(file) + getc(file);
	finfo->ftime = 256 * getc(file) + getc(file);
	return ch;
}

int extract_files(BITFILE *archive, FILES *firstfile, PARAM param) {
//prochz archiv a u kadho souboru se podle masky soubor rozhodne, zda rozbalit i peskoit
	int i;
	int done;
	FILE *file;
	FNAME fname, dname, extract_dir;
	FILES *files;
	FINFO finfo;
	struct ffblk ffblk;
	int over;
	int counter = 0;
	char *str;

	printnf("\n");
	over = scr_write ? 0 : 'V';

	strcpy(fname, firstfile->name);
	if (fname[strlen(fname)-1] == PATH_DIVIDER) { //jestlie je na konci jmna souboru oddlova cesty, chce uivatel rozbalit soubory do adrese
		for (i=0; str = strchr(fname + i, PATH_DIVIDER); i = str - fname + 1) { //vytvoen potebnch adres
			strncpy(dname, fname, str - fname); dname[str-fname] = 0;
			mkdir(dname);
		}
		if (firstfile->next->name) { if (!(firstfile->name = malloc(4))) error(2, NPPVSS); strcpy(firstfile->name, "*.*"); }
		else { files = firstfile; firstfile = firstfile->next; free(files); }
		strcpy(extract_dir, fname);
	}
	else if (param.extract && !strchr(fname, '?') && !strchr(fname, '*') && !findfirst(fname, &ffblk, FA_DIREC) && (ffblk.ff_attrib & FA_DIREC)) { //zjistm, jestli jmno prvnho souboru neoznauje adres
		if (firstfile->next->name) { if (!(firstfile->name = malloc(4))) error(2, NPPVSS); strcpy(firstfile->name, "*.*"); }
		else { files = firstfile; firstfile = firstfile->next; free(files); }
		strcpy(extract_dir, fname);
	} else extract_dir[0] = 0;

	for (i=0; i != EOF; i = ungetc(getc(archive->file), archive->file)) {
		if (read_header(archive->file, &finfo)) error(4, "Neiteln hlavika archivu");
		if (param.onlynames && (str = strrchr(finfo.fname, PATH_DIVIDER))) strcpy(fname, str+1); else strcpy(fname, finfo.fname);
		for (done = 0, files = firstfile; files; files = files->next) //projde seznam zpracovvanch soubor a rozhodne, zda zpracovat
			if (strcmpe(strupr(files->name), fname)) done = 1;
			else if (files->name[0] == EXCLUDE_CHAR && strcmpe(strupr(files->name + 1), fname)) done = 0;
		if (done && param.extract)
			if (param.std_out) { _streams[1] = *freopen("CON", "wb", stdout); file = stdout; }
			else {
				if (!strchr(fname, ':') && fname[0] != PATH_DIVIDER) { strbcpy(dname, extract_dir, fname); strcpy(fname, dname); }
				if (file = fopen(fname, "r")) { fclose(file); done = overwrite(&over, fname); }
				if (done) {
					for (i=0; str = strchr(fname + i, PATH_DIVIDER); i = str - fname + 1) { //vytvoen potebnch adres
						strncpy(dname, fname, str - fname); dname[str-fname] = 0;
						mkdir(dname);
					}
					strupr(fname);
					if (!(file = fopen(fname, "wb"))) { printaf("Nalezeno", fname); printnf("Nelze vytvoit"); done = 0; }
				}
			}
		if (done) printaf(param.extract ? "Rozbaluji" : "Nalezeno", fname);
		extract(archive, file, done && param.extract);

		if (!done) continue;
		if (param.extract) printpf(1.0);
		counter++; printnf("");
		if (!param.extract) continue;
		if (fclose(file)) error(1, "Nelze zavt vstupn soubor");
		if (!param.attrib) continue;
		if (!(file = fopen(fname, "r"))) error(1, "Nelze otet vstupn soubor");
		_dos_setftime(fileno(file), finfo.fdate, finfo.ftime);
		if (fclose(file)) error(1, "Nelze zavt vstupn soubor");
		_dos_setfileattr(fname, finfo.fattr);
	}

	printdf(param.extract ? "Rozbalen" : "Nalezen", counter);
	strcpy(fname, archive->name);
	if (!param.std_out && bclose(archive)) error(1, "Nelze zavt archiv");
	if (!param.std_out && param.erase && unlink(fname)) printnf("Nelze smazat archiv");

	return 0;
}




void help(int code) {
	struct text_info tinfo;

	gettextinfo(&tinfo);
	printnf("      Jakub Vrna, 1998, public domain, verze 1.0");
	printnf("\nPouit: BHC.EXE  pkaz  [pepnae]  [buffer]  [archiv]  [soubor, ...]");
	printnf("\nPkazy:");
	printnf("    a   Zapakovat do archivu");
	printnf("    l   Vypsat obsah archivu");
	printnf("    x   Rozpakovat z archivu");
	printnf("\nBuffer: Velikost bufferu v bytech (1000 - 50000)");
	printnf("Archiv: Jmno souboru s archivem");
	printnf("Soubor: Jmno zpracovvanho souboru, !soubor - nezpracovvat");
	if (tinfo.screenheight < 30) { printef("\n(klvesu pro pokraovn)"); if (scr_write) getch(); printnf(""); }
	printnf("\nPepnae: kad parametr zanajc znakem / nebo -");
	printnf("   -a   Obnovit pvodn atributy, datum a as souboru");
	printnf("   -d   Ukldat absolutn adresov struktury vetn nzvu disku");
	printnf("   -e   Smazat zpracovan soubory");
	printnf("   -i   Vstup brt ze standardnho vstupu");
	printnf("   -l   Jmna soubor brt ze soubor na pkazov dce");
	printnf("   -m   Archiv rozpakovat do novho adrese");
	printnf("   -n   Ukldat pouze jmna soubor bez adresovch struktur");
	printnf("   -o   Vstup dvat na standardn vstup");
	printnf("   -p   Ukldat absolutn adresov struktury krom nzvu disku");
	printnf("   -r   Prochzet strukturu podadres");
	printnf("   -s   Nevypisovat dn hlen, neklst dn dotazy");
	printnf("   -x   Vytvoit samorozbaliteln archiv");
	printnf("   -z   Zprvy vypisovat na standardn vstup msto na chybov");
	exit(code);
}

long getexesize(FILE *file) {
	long exesize;
	long startpos = ftell(file);
	fseek(file, 2, SEEK_SET); exesize = getc(file)+getc(file)*256 + (long) 512 * (getc(file)+getc(file)*256);
	fseek(file, 8, SEEK_SET); exesize -= (long) 16 * getc(file)+getc(file)*256;
	fseek(file, startpos, SEEK_SET);
	return exesize;
}

int main(int argc, char *argv[]) {
	int i;
	long a;
	int done;
	char *str;
	unsigned char command = 0;
	FILE *file;
	FILES *files, *firstfile, *files_temp;
	FNAME archive_name, fname;
	BITFILE *archive;
	char switches[255];
	unsigned maxbuf = 30000;
	struct ffblk ffblk;
	PARAM param;
	long exesize;

	switches[0] = 0;
	if (!(files = malloc(sizeof(FILES)))) error(2, NPPVSS);
	files->next = NULL;
	files->name = NULL;
	firstfile = files;

	for (i=1; i < argc; i++) { //prchod pkazovou dkou
		if (argv[i][0] == '-' || argv[i][0] == PARAM_CHAR) strcat(switches, argv[i] + 1);
		else if ((a = atol(argv[i])) && a >= 1000 && a <= 50000) maxbuf = a;
		else if (!command && !argv[i][1]) command = argv[i][0];
		else if (!files->name) {
			if (!(files->name = malloc(strlen(argv[i])+1))) error(2, NPPVSS);
			strcpy(files->name, argv[i]);
		} else {
			if (!(files->next = malloc(sizeof(FILES)))) error(2, NPPVSS);
			files = files->next;
			files->next = NULL;
			if (!(files->name = malloc(strlen(argv[i])+1))) error(2, NPPVSS);
			strcpy(files->name, argv[i]);
		}
	}

	scr_write = !strchr(switches, 's') + !!strchr(switches, 'z');
	printnf("\nBHC - Nstroj pro kompresi pomoc Bufferovanho Huffmanova kdu");
	if (strchr(switches, '?') || strchr(switches, 'h')) help(0);

	param.attrib = !!strchr(switches, 'a');
	param.absnames = !!strchr(switches, 'd');
	param.erase = !!strchr(switches, 'e');
	param.onlynames = !!strchr(switches, 'n');
	param.pathnames = !!strchr(switches, 'p');
	param.recurse = !!strchr(switches, 'r');
	param.std_in = !!strchr(switches, 'i');
	param.std_out = !!strchr(switches, 'o');
	param.sfx = !!strchr(switches, 'x');

	if (!command) {
		if (!(file = fopen(argv[0], "rb"))) error (1, "Nelze otevt spustiteln soubor");
		fseek(file, 0, SEEK_END);
		if (ftell(file) > (exesize = getexesize(file))) { //samorozbaliteln archiv
			printef("Samorozbaliteln archiv - zahjit rozbalovn? [A, N] ");
			if (scr_write && toupper(getch()) != 'A') { printef("Ne\n"); help(5); } else printef("Ano\n");
			archive = bfopen(file);
			fseek(archive->file, exesize, SEEK_SET);
			command = 'x';
			printnf(""); printaf("Otevrm", argv[0]);
		} else { //chybjc pkaz
			if (fclose(file)) error (1, "Nelze zavt spustiteln soubor");
			help(3);
		}
	}
	else if (command == 'a' ? !param.std_out : !param.std_in) {
		strcpy(fname, firstfile->name);
		if (fname[0] && fname[0] != EXCLUDE_CHAR && !strchr(fname, '?') && !strchr(fname, '*') && fname[strlen(fname)-1] != PATH_DIVIDER) { //jmno prvnho souboru je jednoznan
			strcpy(archive_name, firstfile->name);
			if (firstfile->next) {
				files_temp = firstfile;
				firstfile = firstfile->next;
				free(files_temp);
			} else { if (!(firstfile->name = malloc(4))) error(2, NPPVSS); strcpy(firstfile->name, "*.*"); }
		} else { //automatick uren jmna souboru (jmno prvnho souboru nen jednoznan)
			getcurdir(0, fname);
			if (fname[0]) //jestlie nejsem v koenovm adresi, je jmno souboru jmno aktulnho adrese
				if (str = strrchr(fname, PATH_DIVIDER)) strcpy(archive_name, str + 1);
				else strcpy(archive_name, fname);
			else {
				findfirst("*.*", &ffblk, FA_LABEL);
				if (ffblk.ff_name[0]) strcpy(archive_name, ffblk.ff_name);
				else strcpy(archive_name, "bhc");
			}
		}
		if (strrchr(archive_name, '.') <= strrchr(archive_name, PATH_DIVIDER)) strcat(archive_name, param.sfx ? ".exe" : ".bhc"); //u jmna archivu chyb koncovka
		strupr(archive_name);
		printnf(""); printaf(command == 'a' ? "Vytvm" : "Otevrm", archive_name);
		if (!(archive = bopen(archive_name, command == 'a' ? "wb" : "rb"))) error(1, "Nelze otevt archiv");
	}
	else {
		if (command == 'a') _streams[1] = *freopen("CON", "wb", stdout); else _streams[0] = *freopen("CON", "rb", stdin);
		if (!(archive = bfopen(command == 'a' ? stdout : stdin))) error(1, "Nelze otevt archiv");
	}

	if (command == 'a' && param.sfx) { //jestlie vytvm sfx, nejprve zkopruji exe soubor
		if (!(file = fopen(argv[0], "rb"))) error (1, "Nelze otevt spustiteln soubor");
		exesize = getexesize(file);
		for (a=0; a < exesize && (i = getc(file)) != EOF; a++) putc(i, archive->file);
		if (fclose(file)) error (1, "Nelze zavt spustiteln soubor");
	}

	if (!firstfile->name) { if (!(firstfile->name = malloc(4))) error(2, NPPVSS); strcpy(firstfile->name, "*.*"); } //nezadal jsem dn jmno souboru
	else if (firstfile->name[0] == EXCLUDE_CHAR) { //jestlie je prvn soubor vyluovan, pedadm mu *.*
		files_temp = firstfile;
		if (!(firstfile = malloc(sizeof(FILES)))) error(2, NPPVSS);
		firstfile->next = files_temp;
		if (!(firstfile->name = malloc(4))) error(2, NPPVSS);
		strcpy(firstfile->name, "*.*");
	}

	if (strchr(switches, 'l')) { //pouvm seznam soubor
		for (files = firstfile; files; files=files->next) {
			done = findfirst(files->name, &ffblk, 0);
			free(files->name); files->name = NULL;
			while (!done) {
				if (!(file = fopen(ffblk.ff_name, "r"))) error(1, "Nelze otevt soubor se seznamem soubor");
				while (fgets(fname, MAX_FILENAME, file)) {
					fname[strlen(fname) - 1] = 0;
					if (files->name) {
						files_temp = files->next;
						if (!(files->next = malloc(sizeof(FILES)))) error(2, NPPVSS);
						files = files->next;
						files->next = files_temp;
					}
					if (!(files->name = malloc(strlen(fname)+1))) error(2, NPPVSS);
					strcpy(files->name, fname);
				}
				if (fclose(file)) error(1, "Nelze zavt soubor se seznamem soubor");
				done = findnext(&ffblk);
			}
		}
	}
	if (!(files->next = malloc(sizeof(FILES)))) error(2, NPPVSS);
	files = files->next; files->next = NULL;
	if (!(files->name = malloc(strlen(archive_name)+2))) error(2, NPPVSS);
	files->name[0] = EXCLUDE_CHAR; strcpy(files->name+1, archive_name); //na konec seznamu pidm !archiv

	if (strchr(switches, 'm') && command == 'x' && !param.std_out) { //chci vytvoit adres na rozbalovn
		if (str = strrchr(archive_name, PATH_DIVIDER)) strcpy(archive_name, str + 1);
		if (str = strrchr(archive_name, '.')) str[0] = 0;
		mkdir(archive_name); chdir(archive_name);
		if (!strchr(archive->name, ':') && archive->name[0] != PATH_DIVIDER) { //upraven cesty k souboru
			strcpy(fname, archive->name);
			strcpy(archive->name, ".."); archive->name[3] = 0; archive->name[2] = PATH_DIVIDER;
			strcat(archive->name, fname);
		}
	}

	param.extract = (command == 'x');
	if (command == 'x' || command == 'l') return extract_files(archive, firstfile, param);
	else if (command == 'a') return compress_files(archive, firstfile, maxbuf, param);
	else error(3, "Neznm pkaz"); return 3;
}
